;(function (){
  'use strict';

  var cs_loaded=true;
  //порт для канала в background.js
  var g_bg_port = null; 
  //окно источник сообщения
  var g_return_window = null;
  //generate random tabid
  function gen_tabid () {
    function s4() {
          return Math.floor((1 + Math.random()) * 0x10000)
                 .toString(16)
                 .substring(1);
    }
    return function() {
          return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
             s4() + '-' + s4() + s4() + s4();
    };
  };
  var g_tabid = gen_tabid()();
  //connect к background.js
  function connect(tabid){
      g_bg_port =  browser.runtime.connect({name: g_tabid});
      g_bg_port.onMessage.addListener(function(msg, sender) {
          if(msg.data.type == "result" || msg.data.type == "error" || msg.data.type == "hosterror") {
              g_return_window.postMessage( msg, "*");
              return;
          }
          if(msg.data.type == "callback") {
              result = eval(msg.data.value);
              msg.data.type = "result";
              args = new Array();
              arg = {type: typeof result, value: result};
              args.push(arg);
              msg.data.params = args;
              g_bg_port.postMessage(msg);
          }
      });
      g_bg_port.onDisconnect.addListener(function() {
          g_bg_port = null;
      });
  }

  window.addEventListener("message", function(event) {
      if (event.source != window)
          return;
      if(typeof (event.data.destination) == "undefined" || (event.data.destination != "nmxcrypt" && event.data.destination !="updater")) {
          return;
      }
      g_return_window = event.source;
      if(!g_bg_port)
          connect(g_tabid);
      g_bg_port.postMessage({tabid: g_tabid, data: event.data});
  }, false);

  var script = document.createElement('script');
  script.appendChild(document.createTextNode('(function (){ window.npxcrypt_plugin_script_url="'+ browser.runtime.getURL("nmxcrypt_plugin_api.js") +'"; if (typeof (window.tryAppendFromFirefox) === "undefined"){console.log("tryAppendFromFirefox undef")} else {window.tryAppendFromFirefox();}})();'));
  (document.body || document.head || document.documentElement).appendChild(script);
})();

